; *** ShowPic ver 1.0 (C) 1997 by Dines Justesen ***

;

; This is a very simpel greyscale test, picture 2..5

; are display right after each other as fast as

; possible (no interrupts or delays).

;

; This program does no use the rutine from the rom to

; display the pictures, because the rutine is not

; very well written.

;

; The Group file PICS.82G contains four pictures which

; can be used with the program. The pictures are taken

; from a similar TI85 program, but since i no longer

; have the program  do not know who made them.



#INCLUDE "ti82.h"

#INCLUDE "graph.h"



;--------------------------------------------------------------------------

; Definitions

;--------------------------------------------------------------------------



#DEFINE GetPic(token,addr) LD HL,token \ LD (TokenStart),HL \ RST 10H \ JR C,ExitError \ LD A,(TypeStart) \ CP 7 \ JR NZ,ExitError \ INC DE \ INC DE \ LD (addr),DE

#DEFINE ShowPic(addr) LD HL,(addr) \ CALL_(ShowPicture) \ CALL GET_KEY \ CP $37 \ JR Z,Exit



;--------------------------------------------------------------------------

; Data in text mem

;--------------------------------------------------------------------------



Pic1adr = TEXT_MEM

Pic2adr = TEXT_MEM+2

Pic3adr = TEXT_MEM+4

Pic4adr = TEXT_MEM+8



Pic1Token = $0160

Pic2Token = $0260

Pic3Token = $0360

Pic4Token = $0460



TokenStart = $8029

TypeStart = $8028



;--------------------------------------------------------------------------

; Program

;--------------------------------------------------------------------------



.ORG 0000

        TEXT_START

        ROM_CALL(CLEARLCD)

        GetPic(Pic1Token,Pic1adr)

        GetPic(Pic2Token,Pic2adr)

        GetPic(Pic3Token,Pic3adr)

        GetPic(Pic4Token,Pic4adr)

        JR Loop

ExitError:

        LD HL,Error

        LD DE,(PROGRAM_ADDR)

        ADD HL,DE

        ROM_CALL(D_ZT_STR)     ; Display message

KeyLoop:

        CALL GET_KEY

        CP $37

        JR NZ,KeyLoop

        JR Exit

Loop:

        ShowPic(Pic1adr)

        ShowPic(Pic2adr)

        ShowPic(Pic3adr)

        ShowPic(Pic4adr)

        JR Loop

Exit:

        TEXT_END

        RET



ShowPicture:

        DI

        LD A,7

        CALL $7F3

        OUT ($10),A

        LD A,$80

LineLoop:

        LD D,A          ; Save currect coloum

        CALL $7F3

        OUT ($10),A

        LD A,$20        ; Goto top

        CALL $7F3

        OUT ($10),A

        LD BC,$0C11     ; 40 bytes to port 10

WriteLoop:              ; Write them

        NEG

        NEG

        NEG

        NEG

        OUTI

        JR NZ,WriteLoop

        LD A,D

        INC A

        CP $C0

        JR NZ,LineLoop

        EI

        RET



Error:

.DB "ERROR: PICTURES",0



.END

